function [x,fval,exitflag,output,lambda,grad,hessian] = maxent(N,Aineqinput,bineqinput,Aeqinput,beqinput)
% Returns [P m] where P achives maximum entropy m
% Input dimentions of the probabity function
% and optional inequality constraints (Aineq,bineq)
% and optional equality constraints (Aeq,beq)

if nargin<=4
    Aeqinput=[];
    beqinput=[];
end
if nargin<=2
    Aineqinput=[];
    bineqinput=[];
end
x0 = ones(1,N)/N;
Ai = eye(N).*-1;
bi = zeros(1,N);
Aineq = [Ai; Aineqinput];
bineq = [bi bineqinput];
Ae = ones(1,N);
be = [1];
Aeq = [Ae; Aeqinput];
beq = [be beqinput];
lb = zeros(1,N);
%% Start with the default options
%options = optimset;
%% Modify options setting
%options = optimset(options,'Display', 'off');
%options = optimset(options,'FunValCheck', 'on');
%options = optimset(options,'Algorithm','sqp' , 'MaxIter', 1000);
%options = optimset(options,'MaxIter', 10000);
%options = optimset('Algorithm','sqp' ,'TolFun', 1e-16,'TolX', 1e-16, 'TolCon',1e-16,'MaxFunEvals',100000);
options = optimset('Algorithm','interior-point' ,'TolFun', 1e-6,'TolX', 1e-6, 'TolCon',(1/(4*8182))*(1e-4),'MaxFunEvals',10000000);%,'MaxFunEvals',10000000
%options = optimset('Algorithm', 'interior-point', 'TolFun', 1e-16,'TolX', 1e-16, 'TolCon',1e-16,'MaxFunEvals',100000);%
%options = optimset(options,'TolFun', 1e-10);
%options = optimset(options,'TolX', 1e-10);

%% MaxIter added by Juergen, that is supposed to increase the accuracy of the approximation....
%options = optimset(options,'DerivativeCheck', 'off');
%options = optimset(options,'GradObj', 'on');
[x,fval,exitflag,output,lambda,grad,hessian] = ...
fmincon(@NegEntropy,x0,Aineq,bineq,Aeq,beq,lb,[],[],options);

